GDAL

Public Member Functions | Static Public Member Functions | Public Attributes | Static Public Attributes | List of all members
GDALOctaveMap Class Reference

Class for handling octave layers in SURF-based algorithm. More...

`#include <gdal_simplesurf.h>`

## Public Member Functions
| GDALOctaveMap (int nOctaveStart, int nOctaveEnd)
| Create octave space.
void | ComputeMap (GDALIntegralImage *poImg)
| Calculate Hessian values for octave space (for all stored octave layers) using specified integral image.

## Static Public Member Functions
static bool | PointIsExtremum (int row, int col, GDALOctaveLayer *bot, GDALOctaveLayer *mid, GDALOctaveLayer *top, double threshold)
| Method makes decision that specified point in middle octave layer is maximum among all points from 3x3x3 neighbourhood (surrounding points in bottom, middle and top layers).

## Public Attributes
GDALOctaveLayer *** | pMap
| 2-dimensional array of octave layers
int | octaveStart
| Number of bottom octave.
int | octaveEnd
| Number of top octave.

## Static Public Attributes
static const int | INTERVALS = 4
| Value for constructing internal octave space.

## Detailed Description

Class for handling octave layers in SURF-based algorithm.

Author
  Andrew Migal migal.drew at gmail.com

Class contains OctaveLayers and provides capability to construct octave space and distinguish feature points. Normally this class is used only by SURF-based algorithm.

## Constructor & Destructor Documentation

## ◆ GDALOctaveMap()

GDALOctaveMap::GDALOctaveMap | ( | int | nOctaveStart,
|  | int | nOctaveEnd
| ) |  |

Create octave space.

Octave numbers are start with one. (1, 2, 3, 4, ... )

Parameters

  nOctaveStart | Number of bottom octave
  nOctaveEnd | Number of top octave. Should be equal or greater than OctaveStart

## Member Function Documentation

## ◆ ComputeMap()

void GDALOctaveMap::ComputeMap | ( | GDALIntegralImage * | poImg | ) |

Calculate Hessian values for octave space (for all stored octave layers) using specified integral image.

Parameters

  poImg | Integral image instance which provides necessary data

See also
  GDALOctaveLayer

## ◆ PointIsExtremum()

bool GDALOctaveMap::PointIsExtremum | ( | int | row,
|  | int | col,
|  | GDALOctaveLayer * | bot,
|  | GDALOctaveLayer * | mid,
|  | GDALOctaveLayer * | top,
|  | double | threshold
| ) |  |
| static

Method makes decision that specified point in middle octave layer is maximum among all points from 3x3x3 neighbourhood (surrounding points in bottom, middle and top layers).

Provided layers should be from the same octave's interval. Detects feature points.

Parameters

  row | Row of point, which is candidate to be feature point
  col | Column of point, which is candidate to be feature point
  bot | Bottom octave layer
  mid | Middle octave layer
  top | Top octave layer
  threshold | Threshold for feature point recognition. Detected feature point will have Hessian value greater than this provided threshold.

Returns
  TRUE if candidate was evaluated as feature point or FALSE otherwise.

## Member Data Documentation

## ◆ octaveEnd

int GDALOctaveMap::octaveEnd

Number of top octave.

Should be equal or greater than OctaveStart

The documentation for this class was generated from the following files:

- gdal_simplesurf.h
- gdal_octave.cpp